﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Xml;
using System.Web;
using System.Globalization;
using System.Xml.Linq;

public class Geocoder
{
	public static GeocoderLocation Locate(string query)
	{
        WebRequest request = WebRequest.Create("http://maps.googleapis.com/maps/api/geocode/xml?sensor=false&address=" + HttpUtility.UrlEncode(query));
  //      "http://maps.googleapis.com/maps/api/geocode/xml?address={0}&region=be&sensor=false";
//    http://maps.google.com/maps?output=kml&q=
        //"http://maps.googleapis.com/maps/api/geocode/xml?sensor=false&address="

		using (WebResponse response = request.GetResponse())
		{
			using (Stream stream = response.GetResponseStream())
			{
				//XDocument document = XDocument.Load(new StreamReader(stream));
                XDocument document = XDocument.Load(response.GetResponseStream());

				//XNamespace ns = "http://earth.google.com/kml/2.0";

				XElement longitudeElement = document.Descendants("lng").FirstOrDefault();
				XElement latitudeElement = document.Descendants("lat").FirstOrDefault();

				if (longitudeElement != null && latitudeElement != null)
				{
					return new GeocoderLocation
					{
						Longitude = Double.Parse(longitudeElement.Value, CultureInfo.InvariantCulture),
						Latitude = Double.Parse(latitudeElement.Value, CultureInfo.InvariantCulture)
					};
				}
			}
		}

		return null;
	}
}

